import React, { useState } from 'react';
import useSWR from 'swr';
import { Link } from 'react-router-dom';
import toast, { Toaster } from 'react-hot-toast';
import { ResponseT, TUser} from '../context/UserContext';
import {getProfilData, updateDog} from '../services/PhpApi';
import CreateQr from '../services/CreateQr';
import Img from './Img';
import './Profil.css';

function Profil() 
{
    const [formData, setFormData] = useState({
        email:'',
        name:'',
        phone:'',
        qr_code: null
    });

//    const { data, error, isLoading } = useSWR( user?.qr_id, getDog);
    const { data, error, isLoading, mutate } = useSWR( "profilData", getProfilData);
// data ist dogdata, logindata holt sich getProfilData.php aus $_SESSION
    if (error) return (<div>failed to load</div>);
    if (isLoading) return (<div>loading...</div>);

    const user: TUser =  
    { 
        id: data.data.id,
        qr_id: data.data.qr_id,
        email: data.data.email,
        name: data.data.name
    };
    console.log('Profil data');    
    console.log(data);
    console.log('Profil user');    
    console.log(user);

            // setDog(data);
            // setFormData(
            //     { 
            //         email: data.data.email, 
            //         name: data.data.name,
            //         phone: data.data.phone,
            //         qr_code: data.data.qr_code
            //     });


            if(data.data.qr_code === null && document.getElementById("canvas") != null)
            {
                // qrcode generieren und in der Datenbank speichern
                CreateQr({qr_id: user?.qr_id});
            }              

    let formData_loc =
    {
        email: data.data.email,
        name: data.data.name,
        phone: data.data.phone
    };

                     

    const onChangeInput = (e: React.FormEvent<HTMLInputElement> ) => 
    {
        formData_loc = {...formData,[e.currentTarget.name]:e.currentTarget.value};
        setFormData(
            {
                ...formData,
                [e.currentTarget.name]:e.currentTarget.value
            }
        );    
    }

    function showData(data: any/*, e: React.FormEvent<HTMLFormElement> | React.MouseEvent<HTMLButtonElement>*/)
    {
        if(data.success)
        {
            toast.success('Daten geändert!');

            // setSuccessMsg and setErrMsg force rendering
            // if(e as React.FormEvent<HTMLFormElement> !== null)
            //     (e as React.FormEvent<HTMLFormElement>).currentTarget.reset();
            // if(e as React.MouseEvent<HTMLButtonElement> !== null)
            //     (e as React.MouseEvent<HTMLButtonElement>).currentTarget.onre();
        }
        else if(!data.success && data.message)
        {
            toast.error(data.message);
        }
    }

    const submitForm = async (e: React.FormEvent<HTMLFormElement>) => 
    {
        e.preventDefault();

        if(!Object.values(formData).every(val => val?.trim() !== ''))
        {
            toast.error('Bitte alle Felder ausfüllen!');
            return;
        }
        setFormData(formData);

        const data = await updateDog(formData);
        mutate();
        showData(data);

    }

    const qr_refresh = (e: React.MouseEvent<HTMLButtonElement>) => 
    {
        e.preventDefault();
        formData.qr_code = null;
        setFormData(formData);
        showData(data/*, e*/);

        if(document.getElementById("canvas") != null)
        {
            // qrcode generieren und in der Datenbank speichern
            CreateQr({qr_id: user?.qr_id});
        }              
        // update data with phpapi
        mutate();
    }

    console.log('Profil formData');
    console.log(formData);
    console.log('Profil formData_loc');
    console.log(formData_loc);
    return (
        <div className='Profil'>
            <Toaster toastOptions={{ position: "top-center" }} />
            <h2>Profil</h2>
            <div className='neben'>
                <div className='margin'>
                    {data.data && <Img pth={data.data.picture} className=''/>}
                    <Link to={'/upload'}>Bild ändern</Link>
                </div>
                <div className='margin'>
                    {data.data && <Img pth={data.data.qr_code} className=''/>}
                    <button className='QRakt' onClick={qr_refresh}>QR aktualisieren</button>
                </div>
                <div id="canvas"></div>
            </div>
            <form onSubmit={submitForm}>
                <div className='neben'>
                    <label htmlFor="email">Email: </label>                    
                    <input type="email" name="email" onChange={onChangeInput} placeholder="Deine email" id="email" value={formData_loc.email} required />
                </div>
                <div className='neben'>
                    <label htmlFor="name">Name: </label>
                    <input type="text" name="name" onChange={onChangeInput} id="name" value={formData_loc.name} required />
                </div> 
                <div className='neben'>
                    <label htmlFor="phone">Telefon: </label>
                    <input type="text" name="phone" onChange={onChangeInput} id="phone" value={formData_loc.phone} required />
                </div>
                <button type="submit">Update</button>
            </form>
        <Link to={"/qr"}>QR-Code drucken</Link>
        </div>
  )
}

export default Profil